import java.util.*;

public class BeatModel implements BeatModelInterface {
    
    ArrayList beatObservers = new ArrayList();
    ArrayList bpmObservers = new ArrayList();
    
    int bpm = 0;

    Thread thread;
    
    public void initialize() {
        thread = new Thread(new Runnable() {
            public void run() {
                while (true) {
                    int rate = getBPM();
                    while (rate > 0) {
                        int time = 60000/rate;
                        try {
                            Thread.sleep(time);
                        } catch (Exception e) {
                        }
                        notifyBeatObservers();
                        rate = getBPM();
                    }
                    try {
                        Thread.sleep(500);
                    } catch (Exception e) {
                    }
                }
            }
        });
        thread.setDaemon(true);
        thread.start();
    }
 
    public void on() {
        setBPM(90);
    }
 
    public void off() {
        setBPM(0);
    }
 
    public void setBPM(int bpm) {
        this.bpm = bpm;
        thread.interrupt();
        notifyBPMObservers();
    }
  
    public int getBPM() {
        return bpm;
    }
  
    public void registerObserver(BeatObserver o) {
        beatObservers.add(o);
    }
  
    public void notifyBeatObservers() {
        for(int i = 0; i < beatObservers.size(); i++) {
            BeatObserver observer = (BeatObserver)beatObservers.get(i);
            observer.updateBeat();
        }
    }
  
    public void registerObserver(BPMObserver o) {
        bpmObservers.add(o);
    }
  
    public void notifyBPMObservers() {
        for(int i = 0; i < bpmObservers.size(); i++) {
            BPMObserver observer = (BPMObserver)bpmObservers.get(i);
            observer.updateBPM();
        }
    }

    public void removeObserver(BeatObserver o) {
        int i = beatObservers.indexOf(o);
        if (i >= 0) {
            beatObservers.remove(i);
        }
    }

    public void removeObserver(BPMObserver o) {
        int i = bpmObservers.indexOf(o);
        if (i >= 0) {
            bpmObservers.remove(i);
        }
    }

}
